<template>
<div class="uk-flex-around uk-width-xxlarge">
    <div class="uk-card uk-card-default">
        <div class="uk-card-header">
            <div class="uk-grid-small uk-flex-middle" uk-grid>
                <div class="uk-width-auto">
                    <img class="uk-border-circle" width="40" height="40" :src="loadedProfile.profile_picture">
                </div>
                <div class="uk-width-expand">
                    <h3 class="uk-card-title uk-margin-remove-bottom">{{ loadedProfile.name }}</h3>
                    <p v-on:click="signout" class="uk-text-meta uk-margin-remove-top uk-button uk-button-text"><span uk-icon="sign-out"></span> Sign Out</p>
                </div>
            </div>
        </div>
        <div class="uk-card-body">
            <div class="uk-background-muted uk-padding uk-panel uk-card">
            <p class="uk-article-meta">Profile description:</p>
            <p class="uk-text-center uk-text-lead">{{loadedProfile.description}}</p>
            <a class="uk-button uk-button-text uk-align-right" href="#modal-description" uk-toggle>edit</a>
            </div>

            <div class="uk-margin">
                <div class="uk-column-1-2 uk-text-center uk-column-divider">
                    <div class="uk-card uk-background-default uk-card-body">
                        <!-- label class="uk-form-label" for="form-h-select"></label -->
                    <a class="uk-button uk-button-text" href="#modal-uni" uk-toggle>I goto {{loadedProfile.uni}}</a>
                    </div>
                    <div class="uk-card uk-background-default uk-card-body">
                        <!-- label class="uk-form-label" for="form-h-select"> </label -->
                    <a class="uk-button uk-button-text" href="#modal-tut" uk-toggle>I am {{loadedProfile.tut}}</a>
                    </div>
                </div>
            </div>
        </div>
        <div class="uk-card-footer">
            <p class="uk-article-meta">my courses</p>
            <ul class="uk-list uk-list-striped">
				<li v-for="(value, key) in profileCourses" v-bind:key="key">
    				{{ key }}
 					<button v-on:click="delCourse($event)" v-bind:id="key" type="button" class="uk-align-right" uk-close></button>
				</li>
            </ul>
            <a class="uk-button uk-button-text" href="#modal-course" uk-toggle>add</a>

            <div id="modal-course" uk-modal>
                <div class="uk-modal-dialog">
                    <button class="uk-modal-close-default" type="button" uk-close></button>
                    <div class="uk-modal-header">
                        <h2 class="uk-modal-title">Add course</h2>
                    </div>
                    <div class="uk-modal-body">
                        <div class="uk-margin">
                            <input v-model="addCourse" class="uk-input" type="text" placeholder="course">
                        </div>
                    </div>
                    <div class="uk-modal-footer uk-text-right">
                        <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                        <button v-on:click="updateCourse" class="uk-button uk-button-primary" type="button">Save</button>
                    </div>
                </div>
            </div>
            <div id="modal-description" uk-modal>
                <div class="uk-modal-dialog">
                    <button class="uk-modal-close-default" type="button" uk-close></button>
                    <div class="uk-modal-header">
                        <h2 class="uk-modal-title">Edit description</h2>
                    </div>
                    <div class="uk-modal-body">
                        <div class="uk-margin">
                            <textarea v-model="editedDescription" class="uk-textarea"></textarea>
                        </div>
                    </div>
                    <div class="uk-modal-footer uk-text-right">
                        <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                        <button v-on:click="updatedProfile" class="uk-button uk-button-primary" type="button">Save</button>
                    </div>
                </div>
            </div>
            <div id="modal-tut" uk-modal>
                <div class="uk-modal-dialog">
                    <button class="uk-modal-close-default" type="button" uk-close></button>
                    <div class="uk-modal-header">
                        <h2 class="uk-modal-title">Select tutee/tutor</h2>
                    </div>
                    <div class="uk-modal-body">
                        <div class="uk-form-controls">
                            <select v-model="selectedTut" class="uk-select uk-form-width-large">
                                <option v-for="tut in tuts" v-bind:key="tut.value">
                                {{ tut.text }}
								</option>
                            </select>
                        </div>
                    </div>
                    <div class="uk-modal-footer uk-text-right">
                        <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                        <button v-on:click="updatedProfile" class="uk-button uk-button-primary" type="button">Save</button>
                    </div>
                </div>
            </div>
            <div id="modal-uni" uk-modal>
                <div class="uk-modal-dialog">
                    <button class="uk-modal-close-default" type="button" uk-close></button>
                    <div class="uk-modal-header">
                        <h2 class="uk-modal-title">Select Uni</h2>
                    </div>
                    <div class="uk-modal-body">
                        <div class="uk-form-controls">
  							<select v-model="selectedUni" class="uk-select uk-form-width-large">
   								 <option v-for="uni in unis" v-bind:key="uni.value">
     							 {{ uni.text }}
							     </option>
 							</select>
                        </div>
                    </div>
                    <div class="uk-modal-footer uk-text-right">
                        <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
                        <button v-on:click="updatedProfile" class="uk-button uk-button-primary" type="button">Save</button>
                    </div>
                </div>
            </div>

        </div>
    </div>
</div>
</template>

<script>
export default {
  //props: 'loadedProfile',
  layout: 'app',
  data () {
    return {
    addCourse: '',
    editedDescription: this.$store.state.description,
    selectedUni: this.$store.state.uni,
    selectedTut: this.$store.state.tut,
    id: this.$store.state.uid,
    unis: [
      { text: 'USYD', value: 'USYD' },
      { text: 'UTS', value: 'UTS' },
      { text: 'UNSW', value: 'UNSW' }
    ],
    tuts: [
      { text: 'tutee', value: 'tutee' },
      { text: 'tutor', value: 'tutor' }
    ],
    
    
    }
  },
  methods: {
      signout: function () {
          this.$router.push('/')
          this.$store.dispatch('signout')
      },
      updatedProfile: function () {
          //UIkit.modal('#modal-description').hide()
          //UIkit.modal('#modal-tut').hide()
          //UIkit.modal('#modal-uni').hide()

          this.$store.dispatch('updateProfile', {
              description: this.editedDescription,
              uni: this.selectedUni,
              tut: this.selectedTut,
              uid: this.id
          })
                UIkit.modal('#modal-uni').hide()
                UIkit.modal('#modal-description').hide()
                UIkit.modal('#modal-tut').hide()
          //this.$forceUpdate()

      },
	  updateCourse: function () {     
        if ((/^[A-Za-z]{4}\d{4}$/).test(this.addCourse)) {
            console.log('valid')
            var newcourse = this.addCourse.toLowerCase()
            console.log(newcourse)
            this.$store.dispatch('updateCourse', {
            course: newcourse,
            uid: this.id,
            })
            UIkit.modal('#modal-course').hide()
        }
        else {
            console.log('invalid') 
            alert('invalid course, please use format ABCD1234 - 4 letters 4 numbers')
        }
          
      },
      delCourse: function (event) {
        var targetId = event.currentTarget.id;
        console.log(targetId);
        this.$store.dispatch('delCourse', {
            course: targetId,
            uid: this.id
        })
      } 
  }, 
  computed: {
  	  profileCourses () {
            //return this.$store.state.profileCourses.courses
            return this.$store.getters.loadedCourses
  	  },
      loadedProfile () {
          return this.$store.getters.loadedProfile
      },  
  }

}
</script>